src/Web/Areas/Account/Controllers/HomeController.cs
using DatabaseContext.Context;
using DomainModels.Entities.HumanResource;
using Services.Interfaces;
using System;
using System.Globalization;
using System.Web;
using System.Web.Mvc;
using System.Web.Security;
using ViewModels.Account;
using Infrastructure.Security;
using Infrastructure.Cache.Interfaces;
using Infrastructure.Common;
using Infrastructure.Mail.Interfaces;
using Infrastructure.Exceptions;
using Google.Authenticator;
using DomainModels.Entities.Access;
using Infrastructure.Security.Password;

namespace Web.Areas.Account.Controllers
{
    [AllowAnonymous]
    public class HomeController : Controller
    {

        #region props

        private readonly IUnitOfWork _uow;
        private readonly IUserService _userService;
        private readonly IMailSender _mailSender;
        private readonly ISeoSettingCacheManager _siteSeoSettingCacheManager;
        private readonly IApplicationSettingCacheManager _applicationSettingCacheManager;

        #endregion

        #region ctor

        public HomeController(
            IUnitOfWork uow,
            IUserService userService,
            IMailSender mailSender,
            ISeoSettingCacheManager siteSeoSettingCacheManager,
            IApplicationSettingCacheManager applicationSettingCacheManager)
        {
            _uow = uow;
            _userService = userService;
            _mailSender = mailSender;
            _siteSeoSettingCacheManager = siteSeoSettingCacheManager;
            _applicationSettingCacheManager = applicationSettingCacheManager;
        }

        #endregion


        // common
        private void ValidatePassword(string password)
        {
            var passwordValidateResult = PasswordValidator.Validate(password);

            if (passwordValidateResult == PasswordValidateResult.IsInvalidLengthIsSmall) { throw new CustomException(string.Format("Password length must be greater than {0} characters", PasswordValidator.MinimumLength)); }

            if (passwordValidateResult == PasswordValidateResult.IsInvalidNotContainNumber) { throw new CustomException("Password must have a number at least"); }

            if (passwordValidateResult != PasswordValidateResult.IsValid) { throw new CustomException("an exception occured"); }
        }


        // -------------------------------- Sign Up
        #region signup
        [HttpGet]
        public ActionResult SignUp()
        {
            return GetSignUpView(new SignUpViewModel());
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult SignUp(SignUpViewModel vmSignUp)
        {
            try
            {
                if (!ModelState.IsValid) { return GetSignUpView(vmSignUp); }
                ValidatePassword(vmSignUp.Password);

                var googleAuthenticatorKey = Guid.NewGuid().ToString().Replace("-", "").Substring(0, 10);
                _userService.SignUp(vmSignUp, googleAuthenticatorKey);
                _uow.SaveChanges();

                SetupCode setupInfo = SetUpGoogleAuthenricator(vmSignUp.EmailAddress, googleAuthenticatorKey);

                ViewBag.QrCodeImageUrl = setupInfo.QrCodeSetupImageUrl;
                ViewBag.ManualEntrySetupCode = setupInfo.ManualEntryKey;

                return GetSignUpView(new SignUpViewModel());
            }
            catch (CustomException ex)
            {
                ModelState.AddModelError("", ex.Message);
                return GetSignUpView(vmSignUp);
            }
        }


        private SetupCode SetUpGoogleAuthenricator(string emailAddress, string googleAuthenticatorKey)
        {
            var applicationSetting = _applicationSettingCacheManager.Get();
            var tfa = new TwoFactorAuthenticator();
            var setupInfo = tfa.GenerateSetupCode(applicationSetting.WebsiteDomain, emailAddress, googleAuthenticatorKey, 300, 300);
            return setupInfo;
        }


        // get signup view (for captcha)
        private ActionResult GetSignUpView(SignUpViewModel vmSignUp)
        {
            vmSignUp.cc = CaptchaManager.GenerateHash(new RandomMaker().CreateRandomNumbers(4));
            return View(vmSignUp);
        }
        #endregion


        // -------------------------------- Sign In
        #region signin

        [HttpGet]
        public ActionResult SignIn()
        {
            return GetSignInView(new SignInViewModel());
        }


        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult SignIn(SignInViewModel vmSignIn)
        {
            try
            {
                if (!ModelState.IsValid) { return GetSignInView(vmSignIn); }
                if (!CaptchaManager.IsValid(vmSignIn.cc, vmSignIn.Captcha))  { throw new CustomException("Security code is not valid"); }

                var vmResult = _userService.SignIn(vmSignIn.Username, vmSignIn.Password);

                ValidateUserOnSignIn(vmResult.User);
                
                //ValidateTemporaryPassword(vmResult.User.GoogleAuthenticatorKey, vmSignIn.TemporaryPassword);
                
                //_userService.ValidateDuplicateTemporaryPassword(vmResult.User.Id, vmSignIn.TemporaryPassword);
                //_uow.SaveChanges();

                SetupFormsAuthTicket(vmResult.User, vmSignIn.RememberMe);

                if (vmResult.Role.Name == RoleName.Administrators)
                {
                    // administrators
                    return RedirectToAction("Show", "Dashboard", new { area = "Admin" });
                }
                else
                {
                    if (string.IsNullOrEmpty(vmSignIn.ReturnUrl))
                    {
                        // customers
                        return RedirectToAction("Index", "Dashboard", new { area = "Member" });
                    }
                    else
                    {
                        return Redirect(vmSignIn.ReturnUrl);
                    }
                }
            }
            catch (CustomException ex)
            {
                ModelState.AddModelError("", ex.Message);
                return GetSignInView(vmSignIn);
            }

        }

        private void ValidateTemporaryPassword(string googleAuthenticatorKey, string temporaryPassword)
        {
            var tfa = new TwoFactorAuthenticator();
            var isValid = tfa.ValidateTwoFactorPIN(googleAuthenticatorKey, temporaryPassword);
            if (!isValid) { throw new CustomException("Temporary password was not valid."); }
        }

        private void ValidateUserOnSignIn(User user)
        {
            if (user == null) { throw new CustomException("invalid username or password"); }
            if (user.AccountStatus == AccountStatus.Baned) { throw new CustomException("Your account was accepted. Reason: " + user.BanReason); }
            if (user.AccountStatus == AccountStatus.Deactive) { throw new CustomException("Your account is not active."); }
        }

        // get signin view (for captcha)
        private ActionResult GetSignInView(SignInViewModel vmSignIn)
        {
            vmSignIn.cc = CaptchaManager.GenerateHash(new RandomMaker().CreateRandomNumbers(4));
            return View(vmSignIn);
        }

        private void SetupFormsAuthTicket(User user, bool persistanceFlag)
        {
            var userData = user.Id.ToString(CultureInfo.InvariantCulture);

            var authTicket = new FormsAuthenticationTicket(1, //version
                                user.Username, // name
                                DateTime.Now,             //creation
                                DateTime.Now.AddMinutes(30), //Expiration
                                persistanceFlag, //Persistent
                                userData  // userId
                                );

            var encryptedTicket = FormsAuthentication.Encrypt(authTicket);
            Response.Cookies.Add(new HttpCookie(FormsAuthentication.FormsCookieName, encryptedTicket));
        }

        #endregion


        // -------------------------------- Forget Password
        #region forgetpassword

        [HttpGet]
        public ActionResult ForgetPassword()
        {
            return GetForgetPasswordView(new ForgetPasswordViewModel());
        }


        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult ForgetPassword(ForgetPasswordViewModel vmForgetPassword)
        {
            try
            {
                if (!ModelState.IsValid) { return GetForgetPasswordView(vmForgetPassword); }
                ValidateForgetPaddwordViewModel(vmForgetPassword);

                bool emailSent = SendForgetPasswordEmail(vmForgetPassword);
                if (!emailSent) { throw new CustomException("Some error occored while sending email"); }

                return View("~/Areas/Account/Views/Home/SuccessForgetPassword.cshtml");
            }
            catch (CustomException ex)
            {
                ModelState.AddModelError("", ex.Message);
                return GetForgetPasswordView(vmForgetPassword);
            }
        }

        private void ValidateForgetPaddwordViewModel(ForgetPasswordViewModel vmForgetPassword)
        {
            if (string.IsNullOrEmpty(vmForgetPassword.EmailAddress) || string.IsNullOrWhiteSpace(vmForgetPassword.EmailAddress)) {
                throw new CustomException("Email address is required");
            }

            if (!CaptchaManager.IsValid(vmForgetPassword.cc, vmForgetPassword.Captcha)) {
                throw new CustomException("Security image text is invalid");
            }

            // validate email address
            vmForgetPassword.EmailAddress = vmForgetPassword.EmailAddress.Trim();
            if (!_userService.IsValidEmail(vmForgetPassword.EmailAddress)) {
                throw new CustomException("Email address format is invalid");
            }
        }

        private bool SendForgetPasswordEmail(ForgetPasswordViewModel vmForgetPassword)
        {

src/Web/Controllers/CaptchaController.cs
using System;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Drawing.Text;
using System.IO;
using System.Web.Mvc;
using Infrastructure.Security;

namespace Web.Controllers
{
    [AllowAnonymous]
    public class CaptchaController : Controller
    {
        private static readonly Brush ForeColor = Brushes.Black;
        private const string FontName = "tahoma";
        private const int FontSize = 14;
        private const int Width = 130;
        private const int Height = 35;
        private const int CapchaLength = 4;

        [HttpGet]
        public ActionResult Image(string cc)
        {
            if (string.IsNullOrEmpty(cc) || string.IsNullOrWhiteSpace(cc))
                return null;

            string dehashData = DataEncryptor.DecryptTpl(cc);
            string captchaData = dehashData.Split('_')[0];

            var rand = new Random((int)DateTime.Now.Ticks);

            // image stream
            FileContentResult img = null;

            using (var mem = new MemoryStream())
            using (var bmp = new Bitmap(Width, Height))
            using (var mtrx = new Matrix())
            using (var gfx = Graphics.FromImage((Image)bmp))
            {
                gfx.TextRenderingHint = TextRenderingHint.ClearTypeGridFit;
                gfx.SmoothingMode = SmoothingMode.AntiAlias;
                gfx.FillRectangle(Brushes.White, new Rectangle(0, 0, bmp.Width, bmp.Height));

                //add noise
                int rn, xn, yn;
                var pen = new Pen(Color.Yellow);

                for (int i = 1; i < 10; i++)
                {
                    pen.Color = Color.FromArgb((rand.Next(0, 255)), (rand.Next(0, 255)), (rand.Next(0, 255)));

                    rn = rand.Next(0, (130 / 3));
                    xn = rand.Next(0, 130);
                    yn = rand.Next(0, 30);

                    gfx.DrawEllipse(pen, xn - rn, yn - rn, rn, rn);
                }

                //add chars
                #region draw pic

                float x = 1, y = 1;
                int degree = 10;

                for (int i = 0; i < captchaData.Length; i++)
                {
                    mtrx.Reset();

                    x = (float)(Width * (0.19 * i));

                    y = (float)(Height * 0.19);

                    degree = rand.Next(-25, 25);

                    if (i == 0 && degree > 20)
                    {
                        x += (FontSize + 5);
                        y -= 15;
                    }

                    mtrx.RotateAt(degree, new PointF(x, y));

                    gfx.Transform = mtrx;

                    gfx.DrawString(captchaData[i].ToString(), new Font(FontName, FontSize), ForeColor, x, y);

                    gfx.ResetTransform();
                }
                #endregion

                //render as Jpeg
                bmp.Save(mem, System.Drawing.Imaging.ImageFormat.Jpeg);
                img = this.File(mem.GetBuffer(), "image/Jpeg");
            }

            return img;
        }
	}
}

src/Web/Controllers/HomeController.cs
using Services.Interfaces;
using System.Web.Mvc;
using ViewModels.Base;
using ViewModels.Trade;

namespace Web.Controllers
{
    [AllowAnonymous]
    public class HomeController : Controller
    {

        #region props
        private readonly ICountryService _countryService;
        private readonly ICoinService _coinService;
        private readonly ICurrencyService _currencyService;
        private readonly IPaymentMethodService _paymentMethodService;
        private readonly IAdsService _adsService;
        #endregion

        #region ctor
        public HomeController(
            ICountryService countryService, 
            ICoinService coinService,
            ICurrencyService currencyService,
            IPaymentMethodService paymentMethodService,
            IAdsService adsService)
        {
            _countryService = countryService;
            _coinService = coinService;
            _currencyService = currencyService;
            _paymentMethodService = paymentMethodService;
            _adsService = adsService;
        }
        #endregion


        [HttpGet]
        public ActionResult Index(string lang)
        {
            var vm = new HomePageViewModel();

            #region search form
            var allDllItem = new BaseDdlBaseOnSlugViewModel { Name = "All", Slug = "" };

            vm.Coins = _coinService.GetBaseOnSlugDdlList();
            vm.Coins.Insert(0, allDllItem);

            vm.Countries = _countryService.GetBaseOnSlugDdlList();
            vm.Countries.Insert(0, allDllItem);

            vm.Currencies = _currencyService.GetBaseOnSlugDdlList();
            vm.Currencies.Insert(0, allDllItem);

            vm.PaymentMethods = _paymentMethodService.GetBaseOnSlugDdlList(lang);
            vm.PaymentMethods.Insert(0, allDllItem);
            #endregion

            vm.LastBuyAds = _adsService.GetLast(false, lang , 10);
            vm.LastSellAds = _adsService.GetLast(true, lang, 10);

            ViewBag.Lang = lang;

            return View(vm);
        }

    }
}

src/Web/Areas/Account/Views/Home/ForgetPassword.cshtml
@model ViewModels.Account.ForgetPasswordViewModel

@{
    ViewBag.Title = "Forgot password";
}

<section class="account-box">
    <div class="container">
        <div class="row line-title-seperator">
            <div class="col-md-4">
                <hr class="line">
            </div>
            <div class="col-md-4">
                <h2 class="title">Forgot password</h2>
            </div>
            <div class="col-md-4">
                <hr class="line">
            </div>
        </div>
        <div class="row">
            <div class="col-md-6">
                <div class="alert alert-info">
                    To recover your password, please fill form below.
                    <br />
                    After submit, an email will send to your email address that contains revocery link.
                </div>
            </div>
            <div class="col-md-6">
                @using (Html.BeginForm("ForgetPassword", "Home", FormMethod.Post))
                {
                    @Html.AntiForgeryToken()
                    @Html.ValidationSummary(true)

                    <div class="form-group">
                        @Html.LabelFor(c => c.EmailAddress, new { @class = "label-control" })
                        @Html.TextBoxFor(c => c.EmailAddress, new { @class = "form-control", placeholder = "Required" })
                        @Html.ValidationMessageFor(c => c.EmailAddress)
                    </div>
                    <div class="form-group">
                        <img src="@Url.Action("Image", "Captcha", new { cc = Model.cc, area = "" })" style="margin: 10px 5px 0;border-radius:4px" />

                        <a href="@Url.Action("ForgetPassword", "Home", new { area = "Account" })">
                            <i class="fa fa-refresh"></i>
                        </a>
                    </div>
                    <div class="form-group">
                        @Html.LabelFor(c => c.Captcha, new { @class = "label-control" })
                        @Html.TextBoxFor(c => c.Captcha, new { @class = "form-control small-txt", placeholder = "Required" })
                        @Html.ValidationMessageFor(c => c.Captcha)
                    </div>
                    <br />
                    <div class="form-group">
                        <input class="btn btn-info" type="submit" value="Submit" />
                        &nbsp;&nbsp;
                        @Html.ActionLink("Return to sign in", "SignIn", "Home", new { area = "Account" }, new { @class = "btn btn-success" })
                    </div>
                    <input name="cc" type="hidden" value="@Model.cc" />
                }
            </div>
        </div>
    </div>
</section>


@section scripts{
    <script src="~/Content/lib/js/jquery.validate.min.js"></script>
    <script src="~/Content/lib/js/jquery.validate.unobtrusive.min.js"></script>
}

src/Web/Areas/Account/Views/Home/SP.cshtml
@model ViewModels.Account.SetPasswordViewModel

<section class="account-box">
    <div class="container">
        <div class="row line-title-seperator">
            <div class="col-md-4">
                <hr class="line">
            </div>
            <div class="col-md-4">
                <h2 class="title">Set new password</h2>
            </div>
            <div class="col-md-4">
                <hr class="line">
            </div>
        </div>
        <div class="row">
            <div class="col-lg-6 col-md-6">
                @using (Html.BeginForm("SP", "Home", FormMethod.Post))
                {
                    @Html.AntiForgeryToken()
                    @Html.ValidationSummary(true, "", new { @class = "alert alert-danger" })

                    <div class="form-group">
                        @Html.LabelFor(c => c.Password, new { @class = "label-control" })
                        @Html.PasswordFor(c => c.Password, new { @class = "form-control", placeholder = "الزامی است"})
                        @Html.ValidationMessageFor(c => c.Password)
                    </div>
                    <div class="form-group">
                        @Html.LabelFor(c => c.RePassword, new { @class = "label-control" })
                        @Html.PasswordFor(c => c.RePassword, new { @class = "form-control", placeholder = "الزامی است" })
                        @Html.ValidationMessageFor(c => c.RePassword)
                    </div>
                    <div class="form-group">
                        <img src="@Url.Action("Image", "Captcha", new { cc = Model.cc, area = "" })" />

                        <a href="@Url.Action("sp", "Home", new { uc = Request["uc"], area = "Account" })">
                            <i class="fa fa-refresh"></i>
                        </a>
                    </div>
                    <div class="form-group">
                        @Html.LabelFor(c => c.Captcha, new { @class = "label-control" })
                        @Html.TextBoxFor(c => c.Captcha, new { @class = "form-control small-txt", placeholder = "Required" })
                        @Html.ValidationMessageFor(c => c.Captcha)
                    </div>
                    <div class="form-group">
                        <input class="btn btn-info" type="submit" value='Submit' />
                    </div>
                    <input name="cc" type="hidden" value="@Model.cc"/>
                    @Html.Hidden("ResetPasswordCode", Request["uc"])
                }
            </div>
            <div class="col-lg-6">
                <div class="alert alert-info">
                    Please set new password for your account.
                    <br />
                    After submit, you can sign in with this new password.
                </div>
            </div>
        </div>
    </div>
</section>

@section scripts{
    <script src="~/Content/lib/js/jquery.validate.min.js"></script>
    <script src="~/Content/lib/js/jquery.validate.unobtrusive.min.js"></script>
}

src/Web/Areas/Account/Views/Home/SignIn.cshtml
@model ViewModels.Account.SignInViewModel

@{
    ViewBag.Title = "Sign in";
}

<section class="account-box">
    <div class="container">
        <div class="row line-title-seperator">
            <div class="col-md-4">
                <hr class="line">
            </div>
            <div class="col-md-4">
                <h2 class="title">Sign in</h2>
            </div>
            <div class="col-md-4">
                <hr class="line">
            </div>
        </div>
        <div class="row">
            <div class="col-md-6">
                <div class="alert alert-info">
                    <ul>
                        <li>You should get '<b>Google authenticator temporary password</b>' from Google Authenricator mobile application</li>
                        <li>Don't have an account ? please <b><a href="/Account/SignUp">Sign Up</a></b></li>
                        <li>To return to home page <b><a title="return to home page" href="/">click here</a></b></li>
                    </ul>
                </div>

                <div class="alert alert-success">
                    If you don't have Google Authentication App on your mobile, try links below:
                    <br /><br />
                    <div style="text-align:center">
                        <a class="btn btn-default" title="Download Google Authentication Android version" href="https://play.google.com/store/apps/details?id=com.google.android.apps.authenticator2&amp;hl=en"><i class="fa fa-android"></i> Download Android Version</a>
                        &nbsp;&nbsp;&nbsp;&nbsp;
                        <a class="btn btn-default" title="Download Google Authentication IOS version" href="https://itunes.apple.com/us/app/google-authenticator/id388497605?mt=8"><i class="fa fa-apple"></i> Download IOS Version</a>
                    </div>
                </div>
            </div>
            <div class="col-md-6">
                @using (Html.BeginForm("SignIn", "Home", new { ReturnUrl = Request["returnUrl"] }, FormMethod.Post))
                {
                    @Html.AntiForgeryToken()
                    @Html.ValidationSummary(true)

                    <div class="form-group">
                        @Html.LabelFor(c => c.Username, new { @class = "label-control" })
                        @Html.TextBoxFor(c => c.Username, new { @class = "form-control", placeholder = "Required" })
                        @Html.ValidationMessageFor(c => c.Username)
                    </div>
                    <br />
                    <div class="form-group">
                        @Html.LabelFor(c => c.Password, new { @class = "label-control" })
                        @Html.PasswordFor(c => c.Password, new { @class = "form-control", placeholder = "Required" })
                        @Html.ValidationMessageFor(c => c.Password)
                    </div>
                    <div class="form-group">
                        @Html.LabelFor(c => c.TemporaryPassword, new { @class = "label-control" })
                        @Html.TextBoxFor(c => c.TemporaryPassword, new { @class = "form-control", placeholder = "Required" })
                        @Html.ValidationMessageFor(c => c.TemporaryPassword)
                    </div>
                    <div class="form-group">
                        @Html.CheckBoxFor(c => c.RememberMe)
                        @Html.DisplayNameFor(c => c.RememberMe)
                    </div>
                    <div class="form-group">
                        <img src="@Url.Action("Image", "Captcha", new { cc = Model.cc, area = "" })" />

                        <a  title="refresh serurity image" href="@Url.Action("SignIn", "Home", new { area = "Account" })">
                            <i class="fa fa-refresh"></i>
                        </a>
                    </div>
                    <div class="form-group">
                        @Html.LabelFor(c => c.Captcha, new { @class = "label-control" })
                        @Html.TextBoxFor(c => c.Captcha, new { @class = "form-control small-txt", placeholder = "Required" })
                        @Html.ValidationMessageFor(c => c.Captcha)
                    </div>
                    <br />
                    <div class="form-group">
                        <input class="btn btn-info" type="submit" value='Sign in' />
                        &nbsp;&nbsp;
                        @Html.ActionLink("Forgot password", "ForgetPassword", "Home", new { area = "Account" }, new { @class = "btn btn-success", style = "width:auto;" })
                    </div>
                    <input name="cc" type="hidden" value="@Model.cc"/>
                }
            </div>
        </div>

    </div>
</section>


@section scripts{
    <script src="~/Content/lib/js/jquery.validate.min.js"></script>
    <script src="~/Content/lib/js/jquery.validate.unobtrusive.min.js"></script>
}

src/Web/Areas/Account/Views/Home/SignOut.cshtml
@{
    ViewBag.Title = "sign out";
}

<section class="account-box">
    <div class="container">
        <br /><br />
        <div class="alert alert-success">
            <h4>You have been signed out successfully.</h4>
        </div>
        <br /><br />
        <div style="text-align:center">
            <a href="/" class="btn btn-info btn-lg">Return to home page</a> &nbsp;Or&nbsp; <a href="/@ViewContext.RouteData.Values["lang"]/account/signin" class="btn btn-success btn-lg">Sign in again</a>
        </div>
    </div>
</section>

src/Web/Areas/Account/Views/Home/SuccessForgetPassword.cshtml
@{
    ViewBag.Title = "Message";
}

<section class="account-box">
    <div class="container">
        <br /><br />
        <div class="alert alert-success">
            Information sent to your email address.
            <br />
            Please check your email.
        </div>
    </div>
</section>

src/Web/Areas/Account/Views/Home/SuccessSetPassword.cshtml
@{
    ViewBag.Title = "Message";
}

<section class="account-box">
    <div class="container">
        <br /><br />
        <div class="alert alert-success">
            Your password has been updated successfully
            <br />
            @Html.ActionLink("Sign in", "signin", "Account", new { area = "" }, new { @class = "btn btn-info" })
        </div>
    </div>
</section>